;
; X^_[hMIDIt@C(tH[}bg0/1)t
;

MAX_TRACKS = 17

LEN_TRACK = 6
OFF_TRACK_DELTATIME = 0
OFF_TRACK_DELTATIMEL = 0
OFF_TRACK_DELTATIMEH = 1
OFF_TRACK_DELTATIME_HIGHL = 2
OFF_TRACK_STATUS = 3
OFF_TRACK_P = 4
OFF_TRACK_PL = 4
OFF_TRACK_PH = 5

midifile = 0x500

.area _CODE

start:
	jr main
	jp adjust

main:
	ld HL, #0x7d00
	ld BC, #256
	xor A
	call memset

	; VAM
	call init_serial

	; MIDIt@Cǂݍ
	ld HL, #midifile
	call read_midi_file

	; ŏ̃gbN𓾂
	call get_track_first

main_loop:
	; BREAKL[ꂽ?
	in A, (#0x1f)
	rlca
	jr C, main_last

	; Cxg𓾂
	ld L, OFF_TRACK_PL(IX)
	ld H, OFF_TRACK_PH(IX)
	ld A, (HL)
	inc HL

	; SysEx܂̓^Cxg?
	ld B, A
	and #0xf0
	cp #0xf0
	ld A, B
	jr Z, main_sysex_or_metaevent

	; jOXe[^X?
	bit 7, A
	jr NZ, main_not_running_status
main_running_status:
	dec HL
	ld A, OFF_TRACK_STATUS(IX)
main_not_running_status:
	ld OFF_TRACK_STATUS(IX), A
main_sysex_or_metaevent:

	; ^Cxg?
	cp #0xff
	jr NZ, main_skip
	ld D, (HL)
	inc HL
main_skip:

	; Cxg̒𓾂
	push AF
	push DE
	call get_event_length
	push BC
	push HL

	; ҂
	ld C, OFF_TRACK_DELTATIMEL(IX)
	ld B, OFF_TRACK_DELTATIMEH(IX)
	ld A, C
	or B
	call NZ, delay

	; ^Cxg?
	pop HL
	pop BC
	pop DE
	pop AF
	jr NZ, main_not_metaevent

main_metaevent:
	; ^Cxg
	ld A, D
	cp #0x2f ; gbNI[
	jr Z, main_trackend
	cp #0x51 ; e|ݒ
	jr Z, main_tempo
	jr main_next

main_not_metaevent:
	; MIDICxg𑗐M
	cp #0xf7 ; SysEx(F7)
	call NZ, send_byte
	call send_multibyte

	; MԂZ
	push HL
	ld HL, (#time_e)
	ld DE, (#bit10_length)
	add HL, DE
	add HL, DE
	add HL, DE
	ld (#time_e), HL
	pop HL

main_next:
	; ̓ǂݎʒuֈڂ
	add HL, BC
	ld OFF_TRACK_PL(IX), L
	ld OFF_TRACK_PH(IX), H

	; ̃gbN𓾂
	call get_track_next
	jr NZ, main_loop

main_last:
	; VAMI
	jp term_serial

; gbNI[
main_trackend:
	ld HL, #0
	ld B, H
	ld C, L
	jr main_next

; e|ݒ
main_tempo:
	; DE = tempo / 1024
	ld D, (HL)
	inc HL
	ld E, (HL)
	dec HL
	call set_tempo
	jr main_next

.if 0
putnum:
	ld BC, #10000
	call getnum
	ld BC, #1000
	call getnum
	ld BC, #100
	call getnum
	ld BC, #10
	call getnum
	ld BC, #1
getnum:
	ld A, #-1
getnum_loop:
	inc A
	or A
	sbc HL, BC
	jp NC, getnum_loop
	add HL, BC
	add #"0"
	push HL
	call 0xbe62
	pop HL
	inc E
	ret
.endif

.if 0
puthex:
	push AF
	rrca
	rrca
	rrca
	rrca
	call puthex1
	inc E
	pop AF
	call puthex1
	inc E
	ret

puthex1:
	and #0x0f
	add #"0"
	cp #"0" + 10
	jp C, 0xbe62
	add #-"0" -10 + "A"
	jp 0xbe62

put_track:
	push DE
	push HL
	push BC

	push DE
	ld L, OFF_TRACK_DELTATIMEL(IY)
	ld H, OFF_TRACK_DELTATIMEH(IY)
	call putnum
	pop DE

	inc D
	ld A, OFF_TRACK_PH(IY)
	call puthex
	ld A, OFF_TRACK_PL(IY)
	call puthex

	pop BC
	pop HL
	pop DE
	ret
.endif

;
; ҂
;
; 
; HL:f^^C
;
; o
; AF,DE,HL:j
;
delay:
	; Mԕ
	ld HL, (#time_e)
	ld DE, (#unit_time)
delay_loop:
	ld A, B
	or C
	jr Z, delay_skip
	dec BC
	sbc HL, DE
	jr NC, delay_loop

	; c̑MԂۑ
	inc BC
	add HL, DE
	ld (#time_e), HL

	; ҂
	jp wait_count

delay_skip:
	ld DE, #0
	ld (#time_e), DE
	ret

;
; Cxg̒𓾂
;
; 
; A:Cxg
; HL:AhX
;
; o
; BC:
; HL:̃AhX
; AF:j
;
get_event_length:
	cp #0xf0
	jr NC, decode_length

	ld BC, #2
	cp #0xe0
	ret NC

	ld C, #1
	cp #0xc0
	ret NC

	ld C, #2
	ret

;
; ϒl𓾂
;
; 
; HL:AhX
;
; o
; BC:l
; HL:̃AhX
; AF:j
;
decode_length:
	ld BC, #0
	ld D, B
	ld E, C

decode_length_loop:
	ld A, (HL)
	bit 7, A
	push AF
	and #0x7f
	or C
	ld C, A
	pop AF

	inc HL
	ret Z

	sla C
	rl B
	rl E
	sla C
	rl B
	rl E
	sla C
	rl B
	rl E
	sla C
	rl B
	rl E
	sla C
	rl B
	rl E
	sla C
	rl B
	rl E
	sla C
	rl B
	rl E
	jr decode_length_loop

;
; ŏ̃Cxg𓾂
;
; 
; Ȃ
;
; o
; IX:łf^^C̒ZgbÑAhX
; AF,BC,DE,HL,IY:j
;
get_track_first:
	ld IY, #track
	ld B, #MAX_TRACKS

get_track_first_loop:
	push BC

	ld L, OFF_TRACK_PL(IY)
	ld H, OFF_TRACK_PH(IY)
	inc H
	dec H
	jr Z, get_track_first_skip
	call decode_length
	ld OFF_TRACK_PL(IY), L
	ld OFF_TRACK_PH(IY), H
	ld OFF_TRACK_DELTATIMEL(IY), C
	ld OFF_TRACK_DELTATIMEH(IY), B
	ld OFF_TRACK_DELTATIME_HIGHL(IY), E
get_track_first_skip:
	call next_track

	pop BC
	djnz get_track_first_loop
	jr get_min_track

;
; 2ڈȍ~̃Cxg𓾂
;
; 
; IX:O񑗐MgbÑAhX
;
; o
; IX:łf^^C̒ZgbÑAhX
; AF,BC,DE,HL,IY:j
;
get_track_next:
	; O񑗐MgbÑf^^C𓾂
	ld E, OFF_TRACK_DELTATIMEL(IX)
	ld D, OFF_TRACK_DELTATIMEH(IX)

	; SẴgbÑf^^C, O񑗐MgbÑf^^C
	ld IY, #track
	ld B, #MAX_TRACKS
get_track_next_loop:
	ld A, OFF_TRACK_PH(IY)
	or A
	jr Z, get_track_next_skip
	ld L, OFF_TRACK_DELTATIMEL(IY)
	ld H, OFF_TRACK_DELTATIMEH(IY)
	ld A, OFF_TRACK_DELTATIME_HIGHL(IY)
	or A
	sbc HL, DE
	ld OFF_TRACK_DELTATIMEL(IY), L
	ld OFF_TRACK_DELTATIMEH(IY), H
	jr NC, get_track_next_skip
	dec A
	ld OFF_TRACK_DELTATIME_HIGHL(IY), A
get_track_next_skip:
	call next_track
	djnz get_track_next_loop

	; O񑗐MgbN̎̃f^^C𓾂
	ld L, OFF_TRACK_PL(IX)
	ld H, OFF_TRACK_PH(IX)
	call decode_length
	ld OFF_TRACK_DELTATIMEL(IX), C
	ld OFF_TRACK_DELTATIMEH(IX), B
	ld OFF_TRACK_DELTATIME_HIGHL(IX), E
	ld OFF_TRACK_PL(IX), L
	ld OFF_TRACK_PH(IX), H

;
; łZf^^C̃gbN𓾂
;
; 
; Ȃ
;
; o
; Z:MׂgbNȂ, NZ:MׂgbN
; IX:łf^^C̒ZgbÑAhX
; AF,BC,DE,HL,IY:j
;
get_min_track:
	ld DE, #0xffff
	ld IY, #track
	ld B, #MAX_TRACKS

get_min_track_loop:
	push BC

	; gbN?
	ld A, OFF_TRACK_PH(IY)
	or A
	jr Z, get_min_track_skip

	; f^^C𓾂
	ld L, OFF_TRACK_DELTATIMEL(IY)
	ld H, OFF_TRACK_DELTATIMEH(IY)
	ld A, OFF_TRACK_DELTATIME_HIGHL(IY)

	; f^^C0x10000ȏ̏ꍇ͖
	or A
	jr NZ, get_min_track_skip

	; lς݂̃f^^CƔr
	push HL
	or A
	sbc HL, DE
	pop HL
	jr NC, get_min_track_skip

	; f^^Cۑ
	ld E, L
	ld D, H

	; AhXۑ
	push IY
	pop IX

get_min_track_skip:
	call next_track
	pop BC
	djnz get_min_track_loop

	inc DE
	ld A, E
	or D
	ret

;
; ̃gbNֈڍs
;
; 
; IY:gbN
;
; o
; IY:̃gbN
; F:j
;
next_track:
	push BC

	ld BC, #LEN_TRACK
	add IY, BC

	pop BC
	ret

;
; MIDIf[^ǂݍ
;
; 
; HL:MIDIf[^̐擪
;
; o
; AF,BC,DE,HL:j
;
read_midi_file:
	; wb_`Nʎqǂ
	inc HL
	inc HL
	inc HL
	inc HL

	; wb_`Nf[^ǂ
	inc HL
	inc HL
	ld D, (HL)
	inc HL
	ld E, (HL)
	inc HL

	; gbN̐擪AhXpush
	add HL, DE
	push HL
	or A
	sbc HL, DE

	; tH[}bgǂ
	inc HL
	inc HL

	; gbNǂ
	inc HL
	ld B, (HL)
	inc HL

	; \ǂ
	ld D, (HL)
	inc HL
	ld E, (HL)
	ld (#div), DE

	; tempo
	ld DE, #500000 / 256
	call set_tempo

	; gbN̐擪AhXpop
	pop HL

	ld IY, #track

read_midi_file_loop:
	push BC

	; gbN`Nʎqǂ
	inc HL
	inc HL
	inc HL
	inc HL

	; gbNf[^ǂ
	inc HL
	inc HL
	ld B, (HL)
	inc HL
	ld C, (HL)
	inc HL

	; gbNf[^ǂ
	ld OFF_TRACK_PL(IY), L
	ld OFF_TRACK_PH(IY), H
	add HL, BC

	pop BC
	call next_track
	djnz read_midi_file_loop
	ret

;
; e|ݒ肷
;
; 
; DE:e|(l̒ / 256)
;
; o
; AF,DE:j
;
set_tempo:
	push HL
	push BC

	; 1f^^C̃JEg = 31250 * (L/10) / 1000 / 1000 * tempo' * 256 / div
	;                                 = 0.8L * tempo' / div
	; BC = \ * 5
	ld HL, (#div)
	ld BC, (#div)
	add HL, HL
	add HL, HL
	add HL, BC
	ld C, L
	ld B, H

	; DEHL = tempo' * 10bit̃JEg * 4߂
	ld A, (#bit10_length)
	call mul32
	sla L
	rl H
	rl E
	rl D
	sla L
	rl H
	rl E
	rl D

	; HL = DEHL / BC
	call div32
	ld (#unit_time), HL

	pop BC
	pop HL
	ret

;
; DEHL = A * DE (vC)
;
; 
; A:l
; DE:l
;
; o
; DE:()
; HL:()
; AF:j
;
mul32:
	push BC

	ld B, D
	ld C, E
	ld DE, #0
	ld HL, #0

	or A
	jp Z, mul32_last

mul32_loop:
	add HL, BC
	jp NC, mul32_skip
	inc DE
mul32_skip:
	dec A
	jp NZ, mul32_loop

mul32_last:
	pop BC
	ret

;
; HL = DEHL / BC
;
; 
; DE:鐔()
; HL:鐔()
; BC:鐔
;
; o
; HL:
; AF,DE:j
;
div32::
	push IX

	ld IX, #-1
div32_loop:
	inc IX

	or A
	sbc HL, BC
	jp NC, div32_loop
	dec DE
	ld A, D
	and E
	inc A
	jp NZ, div32_loop

	push IX
	pop HL

	pop IX
	ret

;
; ɒl
;
; 
; A:l
; BC:
; HL:AhX
;
; o
; AF,BC,HL:j
;
memset:
	push DE

	dec BC
	ld D, H
	ld E, L
	inc DE
	ld (HL), A
	ldir

	pop DE
	ret

;
; f[^
;

.area _DATA

; \
div:
	.ds 2

; Pʎ
unit_time:
	.ds 2

; M
time_e:
	.ds 2

; gbN
track:
	.ds MAX_TRACKS * LEN_TRACK

; eof
